org.apache.fop.render.intermediate

## Interface IFPainter

- All Known Implementing Classes:
    AbstractIFPainter, AFPPainter, IFSerializer, Java2DPainter, PCLPainter, PDFPainter, PSPainter

      public interface IFPainter

  Interface used to paint whole documents layouted by Apache FOP.

  Call sequence:

       startDocument()
         startDocumentHeader()
         [handleExtension()]*
         endDocumentHeader()
         [
         startPageSequence()
           [
           startPage()
             startPageHeader()
               [handleExtension()]*
             endPageHeader()
             startPageContent()
               (#pageContent)+
             endPageContent()
             startPageTrailer()
               (addTarget())*
             endPageTrailer()
           endPage()
           ]*
         endPageSequence()
         ]*
         startDocumentTrailer()
         [handleExtension()]*
         endDocumentTrailer()
       endDocument()

       #box:
       startBox()
       (#pageContent)+
       endBox()

       #pageContent:
       (
         setFont() |
         drawText() |
         drawRect() |
         drawImage() |
         TODO etc. etc. |
         handleExtensionObject()
       )

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `clipBackground(Rectangle rect, BorderProps bpsBefore, BorderProps bpsAfter, BorderProps bpsStart, BorderProps bpsEnd)` Restricts the current clipping region to the inner border.
    `void` | `clipRect(Rectangle rect)` Restricts the current clipping region with the given rectangle.
    `void` | `drawBorderRect(Rectangle rect, BorderProps top, BorderProps bottom, BorderProps left, BorderProps right, Color innerBackgroundColor)` Draws a border rectangle.
    `void` | `drawImage(Document doc, Rectangle rect)` Draws an image (represented by a DOM document) inside a given rectangle.
    `void` | `drawImage(String uri, Rectangle rect)` Draws an image identified by a URI inside a given rectangle.
    `void` | `drawLine(Point start, Point end, int width, Color color, RuleStyle style)` Draws a line.
    `void` | `drawText(int x, int y, int letterSpacing, int wordSpacing, int[][] dp, String text)` Draws text.
    `void` | `drawText(int x, int y, int letterSpacing, int wordSpacing, int[][] dp, String text, boolean nextIsSpace)`
    `void` | `endGroup()` Ends the current group and restores the previous coordinate system (and layer).
    `void` | `endViewport()` Ends the current viewport and restores the previous coordinate system.
    `void` | `fillRect(Rectangle rect, Paint fill)` Fills a rectangular area.
    `boolean` | `isBackgroundRequired(BorderProps bpsBefore, BorderProps bpsAfter, BorderProps bpsStart, BorderProps bpsEnd)` TODO Painter-specific rounded borders logic required background drawing to be made optional.
    `void` | `setFont(String family, String style, Integer weight, String variant, Integer size, Color color)` Updates the current font.
    `void` | `startGroup(AffineTransform[] transforms, String layer)` Starts a new group of graphical elements.
    `void` | `startGroup(AffineTransform transform, String layer)` Starts a new group of graphical elements.
    `void` | `startViewport(AffineTransform[] transforms, Dimension size, Rectangle clipRect)` Starts a new viewport, establishing a new coordinate system.
    `void` | `startViewport(AffineTransform transform, Dimension size, Rectangle clipRect)` Starts a new viewport, establishing a new coordinate system.

- - ### Method Detail

    - #### startViewport

          void startViewport(AffineTransform transform,
                             Dimension size,
                             Rectangle clipRect)
                      throws IFException

      Starts a new viewport, establishing a new coordinate system. A viewport has a size and can optionally be clipped. Corresponds to SVG's svg element.
      Parameters:
        `transform` - the transformation matrix establishing the new coordinate system
        `size` - the size of the viewport
        `clipRect` - the clipping rectangle (may be null)
      Throws:
        `IFException` - if an error occurs while handling this element

    - #### startViewport

          void startViewport(AffineTransform[] transforms,
                             Dimension size,
                             Rectangle clipRect)
                      throws IFException

      Starts a new viewport, establishing a new coordinate system. A viewport has a size and can optionally be clipped. Corresponds to SVG's svg element.
      Parameters:
        `transforms` - a series of transformation matrices establishing the new coordinate system
        `size` - the size of the viewport
        `clipRect` - the clipping rectangle (may be null)
      Throws:
        `IFException` - if an error occurs while handling this element

    - #### endViewport

          void endViewport()
                    throws IFException

      Ends the current viewport and restores the previous coordinate system.
      Throws:
        `IFException` - if an error occurs while handling this element

    - #### startGroup

          void startGroup(AffineTransform[] transforms,
                          String layer)
                   throws IFException

      Starts a new group of graphical elements. Corresponds to SVG's g element.
      Parameters:
        `transforms` - a series of transformation matrices establishing the new coordinate system
        `layer` - an optional layer label (or null if none)
      Throws:
        `IFException` - if an error occurs while handling this element

    - #### startGroup

          void startGroup(AffineTransform transform,
                          String layer)
                   throws IFException

      Starts a new group of graphical elements. Corresponds to SVG's g element.
      Parameters:
        `transform` - the transformation matrix establishing the new coordinate system
        `layer` - an optional layer label (or null if none)
      Throws:
        `IFException` - if an error occurs while handling this element

    - #### endGroup

          void endGroup()
                 throws IFException

      Ends the current group and restores the previous coordinate system (and layer).
      Throws:
        `IFException` - if an error occurs while handling this element

    - #### setFont

          void setFont(String family,
                       String style,
                       Integer weight,
                       String variant,
                       Integer size,
                       Color color)
                throws IFException

      Updates the current font.
      Parameters:
        `family` - the font family (or null if there's no change)
        `style` - the font style (or null if there's no change)
        `weight` - the font weight (or null if there's no change)
        `variant` - the font variant (or null if there's no change)
        `size` - the font size (or null if there's no change)
        `color` - the text color (or null if there's no change)
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### drawText

          void drawText(int x,
                        int y,
                        int letterSpacing,
                        int wordSpacing,
                        int[][] dp,
                        String text)
                 throws IFException

      Draws text. The initial coordinates (x and y) point to the starting point at the normal baseline of the font. The parameters letterSpacing, wordSpacing and the array dx are optional and can be used to influence character positioning (for example, for kerning).
      Parameters:
        `x` - X-coordinate of the starting point of the text
        `y` - Y-coordinate of the starting point of the text
        `letterSpacing` - additional spacing between characters (may be 0)
        `wordSpacing` - additional spacing between words (may be 0)
        `dp` - an array of 4-tuples, expressing [X,Y] placment adjustments and [X,Y] advancement adjustments, in that order (may be null); if not null, then adjustments.length must be the same as text.length()
        `text` - the text
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### drawText

          void drawText(int x,
                        int y,
                        int letterSpacing,
                        int wordSpacing,
                        int[][] dp,
                        String text,
                        boolean nextIsSpace)
                 throws IFException

      Throws:
        `IFException`

    - #### clipRect

          void clipRect(Rectangle rect)
                 throws IFException

      Restricts the current clipping region with the given rectangle.
      Parameters:
        `rect` - the rectangle's coordinates and extent
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### clipBackground

          void clipBackground(Rectangle rect,
                              BorderProps bpsBefore,
                              BorderProps bpsAfter,
                              BorderProps bpsStart,
                              BorderProps bpsEnd)
                       throws IFException

      Restricts the current clipping region to the inner border.
      Parameters:
        `rect` - the rectangle's coordinates and extent
        `bpsBefore` - the border segment on the before-side (top)
        `bpsAfter` - the border segment on the after-side (bottom)
        `bpsStart` - the border segment on the start-side (left)
        `bpsEnd` - the border segment on the end-side (right)
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### isBackgroundRequired

          boolean isBackgroundRequired(BorderProps bpsBefore,
                                       BorderProps bpsAfter,
                                       BorderProps bpsStart,
                                       BorderProps bpsEnd)

      TODO Painter-specific rounded borders logic required background drawing to be made optional. A future refactoring of the rounded borders code should aim to make the need for this abstraction obsolete
      Parameters:
        `bpsBefore` - the before border
        `bpsAfter` - the after border
        `bpsStart` - the start border
        `bpsEnd` - the end border
      Returns:
        true if and only if background drawing is required

    - #### fillRect

          void fillRect(Rectangle rect,
                        Paint fill)
                 throws IFException

      Fills a rectangular area.
      Parameters:
        `rect` - the rectangle's coordinates and extent
        `fill` - the fill paint
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### drawBorderRect

          void drawBorderRect(Rectangle rect,
                              BorderProps top,
                              BorderProps bottom,
                              BorderProps left,
                              BorderProps right,
                              Color innerBackgroundColor)
                       throws IFException

      Draws a border rectangle. The border segments are specified through `BorderProps` instances.
      Parameters:
        `rect` - the rectangle's coordinates and extent
        `top` - the border segment on the top edge
        `bottom` - the border segment on the bottom edge
        `left` - the border segment on the left edge
        `right` - the border segment on the right edge
        `innerBackgroundColor` - the color of the inner background
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### drawLine

          void drawLine(Point start,
                        Point end,
                        int width,
                        Color color,
                        RuleStyle style)
                 throws IFException

      Draws a line. NOTE: Currently, only horizontal lines are implemented!
      Parameters:
        `start` - the start point of the line
        `end` - the end point of the line
        `width` - the line width
        `color` - the line color
        `style` - the line style (using the Constants.EN_* constants for the rule-style property)
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### drawImage

          void drawImage(String uri,
                         Rectangle rect)
                  throws IFException

      Draws an image identified by a URI inside a given rectangle. This is the equivalent to an fo:external-graphic in XSL-FO.
      Parameters:
        `uri` - the image's URI
        `rect` - the rectangle in which the image shall be painted
      Throws:
        `IFException` - if an error occurs while handling this event

    - #### drawImage

          void drawImage(Document doc,
                         Rectangle rect)
                  throws IFException

      Draws an image (represented by a DOM document) inside a given rectangle. This is the equivalent to an fo:instream-foreign-object in XSL-FO.
      Parameters:
        `doc` - the DOM document containing the foreign object
        `rect` - the rectangle in which the image shall be painted
      Throws:
        `IFException` - if an error occurs while handling this event

Copyright © 2025 Apache Software Foundation. All rights reserved.